summaryrefslogtreecommitdiffstats
path: root/system
diff options
context:
space:
mode:
author pyllyukko <pyllyukko@maimed.org>2019-06-15 07:29:23 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2019-06-15 07:29:23 +0700
commitb78040fcf6930c9a96325e02044fc300a55f84be (patch)
tree226fcd39b88f229c18e9f6c595cc090c14f030f6 /system
parent40b67c6a0a733d4789f761106ca76e6761527c72 (diff)
downloadslackbuilds-b78040fcf6930c9a96325e02044fc300a55f84be.tar.gz
slackbuilds-b78040fcf6930c9a96325e02044fc300a55f84be.tar.xz
system/tpe-kmod: Added (Trusted Path Execution Linux Kernel Module).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'system')
-rw-r--r--system/tpe-kmod/README8
-rw-r--r--system/tpe-kmod/doinst.sh15
-rw-r--r--system/tpe-kmod/slack-desc19
-rw-r--r--system/tpe-kmod/tpe-kmod.SlackBuild96
-rw-r--r--system/tpe-kmod/tpe-kmod.info10
5 files changed, 148 insertions, 0 deletions
diff --git a/system/tpe-kmod/README b/system/tpe-kmod/README
new file mode 100644
index 0000000000..87899273e1
--- /dev/null
+++ b/system/tpe-kmod/README
@@ -0,0 +1,8 @@
+Trusted Path Execution is a security feature that denies users from executing
+programs that are not owned by root, or are writable. This closes the door on a
+whole category of exploits where a malicious user tries to execute his or her
+own code to attack the system.
+
+Since this module doesn't use any kind of ACLs, it works out of the box with no
+configuration. It isn't complicated to test or deploy to current production
+systems. Just install it and you're done!
diff --git a/system/tpe-kmod/doinst.sh b/system/tpe-kmod/doinst.sh
new file mode 100644
index 0000000000..ecc1b57efb
--- /dev/null
+++ b/system/tpe-kmod/doinst.sh
@@ -0,0 +1,15 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+config etc/modprobe.d/tpe.conf.new
+config etc/sysctl.d/tpe.conf.new
diff --git a/system/tpe-kmod/slack-desc b/system/tpe-kmod/slack-desc
new file mode 100644
index 0000000000..c7475ac19b
--- /dev/null
+++ b/system/tpe-kmod/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+tpe-kmod: tpe-kmod (Trusted Path Execution Linux Kernel Module)
+tpe-kmod:
+tpe-kmod: Trusted Path Execution is a security feature that denies users from
+tpe-kmod: executing programs that are not owned by root, or are writable.
+tpe-kmod: This closes the door on a whole category of exploits where a malicious
+tpe-kmod: user tries to execute his or her own code to attack the system.
+tpe-kmod:
+tpe-kmod:
+tpe-kmod:
+tpe-kmod: Homepage: https://github.com/cormander/tpe-lkm
+tpe-kmod:
diff --git a/system/tpe-kmod/tpe-kmod.SlackBuild b/system/tpe-kmod/tpe-kmod.SlackBuild
new file mode 100644
index 0000000000..ab96e3312c
--- /dev/null
+++ b/system/tpe-kmod/tpe-kmod.SlackBuild
@@ -0,0 +1,96 @@
+#!/bin/sh
+
+# Slackware build script for TPE LKM
+
+# Copyright 2019 pyllyukko
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=tpe-kmod
+VERSION=${VERSION:-2.0.3}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd tpe-lkm-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+make
+make install_files DESTDIR=$PKG
+
+mv -v $PKG/etc/sysctl.d/tpe.conf{,.new}
+mv -v $PKG/etc/modprobe.d/tpe.conf{,.new}
+
+# Sign the kernel module (if available)
+if [ -f /proc/config.gz ]
+then
+ if [ -z "${CONFIG_MODULE_SIG_HASH}" ]; then
+ eval $(zgrep "^CONFIG_MODULE_SIG_HASH=" /proc/config.gz)
+ fi
+ KERNVER=$(uname -r)
+ KERNSRC=${KERNSRC:-/lib/modules/${KERNVER}/source}
+ if [ -n "${CONFIG_MODULE_SIG_HASH}" ] && \
+ [ -f $KERNSRC/certs/signing_key.pem ] && \
+ [ -f $KERNSRC/certs/signing_key.x509 ] && \
+ [ -x $KERNSRC/scripts/sign-file ]
+ then
+ $KERNSRC/scripts/sign-file \
+ ${CONFIG_MODULE_SIG_HASH} \
+ $KERNSRC/certs/signing_key.pem \
+ $KERNSRC/certs/signing_key.x509 \
+ ${PKG}/lib/modules/${KERNVER}/extra/tpe/tpe.ko
+ fi
+fi
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ FAQ GPL INSTALL LICENSE README \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/system/tpe-kmod/tpe-kmod.info b/system/tpe-kmod/tpe-kmod.info
new file mode 100644
index 0000000000..0fdd1c8990
--- /dev/null
+++ b/system/tpe-kmod/tpe-kmod.info
@@ -0,0 +1,10 @@
+PRGNAM="tpe-kmod"
+VERSION="2.0.3"
+HOMEPAGE="https://github.com/cormander/tpe-lkm"
+DOWNLOAD="https://github.com/cormander/tpe-lkm/archive/2.0.3/tpe-kmod-2.0.3.tar.gz"
+MD5SUM="b6f0520c0cec4d5a7fd5b8de514fefa9"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="pyllyukko"
+EMAIL="pyllyukko@maimed.org"